
'\"
'\" The contents of this file are subject to the AOLserver Public License
'\" Version 1.1 (the "License"); you may not use this file except in
'\" compliance with the License. You may obtain a copy of the License at
'\" http://aolserver.com/.
'\"
'\" Software distributed under the License is distributed on an "AS IS"
'\" basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
'\" the License for the specific language governing rights and limitations
'\" under the License.
'\"
'\" The Original Code is AOLserver Code and related documentation
'\" distributed by AOL.
'\" 
'\" The Initial Developer of the Original Code is America Online,
'\" Inc. Portions created by AOL are Copyright (C) 1999 America Online,
'\" Inc. All Rights Reserved.
'\"
'\" Alternatively, the contents of this file may be used under the terms
'\" of the GNU General Public License (the "GPL"), in which case the
'\" provisions of GPL are applicable instead of those above.  If you wish
'\" to allow use of your version of this file only under the terms of the
'\" GPL and not to allow others to use your version of this file under the
'\" License, indicate your decision by deleting the provisions above and
'\" replace them with the notice and other provisions required by the GPL.
'\" If you do not delete the provisions above, a recipient may use your
'\" version of this file under either the License or the GPL.
'\" 
'\"
'\" $Header: /cvsroot/aolserver/aolserver/doc/ns_uuencode.n,v 1.4 2003/04/10 22:01:22 shmooved Exp $
'\"
'\" 
.so man.macros

.TH ns_uuencode n 4.0 AOLserver "AOLserver Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
ns_uudecode, ns_uuencode \- commands
.SH SYNOPSIS
\fBns_uudecode \fIstring\fR
.sp
\fBns_uuencode \fIstring\fR
.BE

.SH DESCRIPTION
.PP
\fBns_uudecode\fR performs HTTP-style uudecoding and returns the decoded
value.

.PP
\fBns_uuencode\fR performs HTTP-style uuencoding and returns the encoding 
value.  The input \fIstring\fR is limited to a maximum length of 48
characters.  The encoding string will be approximately 33% longer
than the original.

.PP
\fBNote:\fR This is HTTP-style uuencoding/uudecoding which is sometimes
called "htuu" (see RFC 1113).  It is not compatible with the 
format used by the Unix uuencode/uudecode commands, nor is it
base-64 encoding.  

.PP
For base-64 encoding, consider using the base64 Tcl package in tcllib 
(see http://tcllib.sourceforge.net).

.SH EXAMPLES
.PP
 nscp> ns_uuencode username
 dXNlcm5hbWU=

 nscp> ns_uudecode dXNlcm5hbWU=
 username

.SH "SEE ALSO"
nsd(1)

.SH KEYWORDS

